#include "TimerOne.h"

# define MAX_STEP 1.3E+5//130000.0 //Максимальная длина шага в десятках микросекунд - ограничение 16битового беззенакового целого.
# define MIN_STEP 40.0 // //Минимальная длина шага в десятках микросекунд - ограничение возможностями мотора.

//# define RAZRESHENYE 10000.0 //Разрешение к прерыванию привязано, равно (количеству микросекунд в цикле)/(время прерывания)

# define RAZRESHENYE 8333.33 //Разрешение к прерыванию привязано, равно (количеству микросекунд в цикле)/(время прерывания)

# define MAX_n_step 350.0

volatile uint16_t schetchik_long_step_L = 0;
volatile uint16_t schetchik_long_step_R = 0;
bool napralenie_R = true;
bool napralenie_L = true;
bool real_napralenie_R = true; //Действующее направление
bool real_napralenie_L = true; //Действующее направление

bool flag_off_step = false; //флаг завершения активной части шага
bool flag_off_step_R = false; //флаг завершения активной части шага
bool flag_off_step_L = false; //флаг завершения активной части шага

volatile bool  flag_new_command;  //Флаг наличия команды на изменеие скорости мотора.

uint16_t command_step_long_L_activ, command_step_long_R_activ;

volatile uint16_t tek_step_long_L_activ;
volatile uint16_t tek_step_long_R_activ;

uint8_t flag_move_old = 0; //флаг движения до вызова интеграла
float command_step_long_L = 0; //Длиное беззнаковое целое - расчетная длина шага.
float command_step_long_R = 0;

bool flag_turn_command = false, flag_turn = false; //флаг поворота

float filter_speed = 0, speed_2 = 0, speed_3 = 0;
//==========================================================================
//==========================================================================
void step_command(float &angle_of_depression, float &disbalance, float &speed_step_in_sec, float &turn) //1-угол наклона робота 2-дисбаланс колес - для поворотов, скорость движения робота
{
  float n_steps;
  float n_steps_L; float n_steps_R;

   n_steps = (speed_2 + 8.3411 * (angle_of_depression +  disbalance) - speed_step_in_sec + SumIntegral) * 1.6;
 
   if ((speed_step_in_sec == 0) && (turn == 0)) {
    if (flag_move_old == 0)
      SumIntegral += n_steps * 0.1;
    else {
      flag_move_old--;
    }
  }
  else
  {
    flag_move_old = 5;
  }
  if (turn != 0.0)
  {
    n_steps_R = n_steps + turn;
    n_steps_L = n_steps - turn;
    if (n_steps_L > MAX_n_step) n_steps_L = MAX_n_step;
    else if (n_steps_L < (-MAX_n_step)) n_steps_L = -MAX_n_step;
    if (n_steps_R > MAX_n_step) n_steps_R = MAX_n_step;
    else if (n_steps_R < (-MAX_n_step)) n_steps_R = -MAX_n_step;

    command_step_long_R = RAZRESHENYE / n_steps_R;
    command_step_long_L = RAZRESHENYE / n_steps_L;

    if (command_step_long_R > MAX_STEP) command_step_long_R = MAX_STEP;
    else if (command_step_long_R < (-MAX_STEP)) command_step_long_R = -MAX_STEP;

    if (command_step_long_L > MAX_STEP) command_step_long_L = MAX_STEP;
    else if (command_step_long_L < (-MAX_STEP)) command_step_long_L = -MAX_STEP;

    speed_2 = (n_steps_R + n_steps_L) * 0.5;
  }
  else
  {
    if (n_steps > MAX_n_step) n_steps = MAX_n_step;
    else if (n_steps < (-MAX_n_step)) n_steps = -MAX_n_step;

    speed_2 = n_steps;

    command_step_long_L = RAZRESHENYE / n_steps;

    if (command_step_long_L > MAX_STEP) command_step_long_L = MAX_STEP;
    else if (command_step_long_L < (-MAX_STEP)) command_step_long_L = -MAX_STEP;

    command_step_long_R = command_step_long_L;
  }
  //======================
  if (command_step_long_R < 0.0) {
    napralenie_R = false;
    command_step_long_R = -command_step_long_R;
  }
  else
  {
    napralenie_R = true;
  }
  //=======================
  if (command_step_long_L < 0.0)
  {
    napralenie_L = false;
    command_step_long_L = -command_step_long_L;
  }
  else
  {
    napralenie_L = true;
  }
  command_step_long_R_activ = uint16_t(round (command_step_long_R * 0.5)) + 1; //Полушаг
  command_step_long_L_activ = uint16_t(round (command_step_long_L * 0.5)) + 1; //Полушаг

  //Должна идти последней командой символизирует, что обработка закончена и следует принять расчитанную информацию в прерывании к исполнению

  //=========================================
  //=========================================
  //======================================================
  if (real_napralenie_L == napralenie_L) //Если направление не изменилось
  {
    cli();
    tek_step_long_L_activ = command_step_long_L_activ;
    sei();
    if (schetchik_long_step_L > tek_step_long_L_activ)
    {
      cli();
      schetchik_long_step_L = tek_step_long_L_activ;
      sei();
    }
  }
  else //Если направление шага изменилось
  {
    cli();
    tek_step_long_L_activ = command_step_long_L_activ;
    PORTB &= B11101111; //Отключаем сигнал шага
    schetchik_long_step_L = 0;//tek_step_long_L_activ;
    PORTB ^= B00001000;
    sei();
    real_napralenie_L = napralenie_L;
  }
  //======================================================
  //======================================================
  if (real_napralenie_R == napralenie_R) //Если направление не изменилось
  {
    cli();
    tek_step_long_R_activ = command_step_long_R_activ;
    sei();
    if (schetchik_long_step_R > tek_step_long_R_activ)
    {
      cli();
      schetchik_long_step_R = tek_step_long_R_activ;
      sei();
    }
  }
  else //Если направление шага изменилось
  {
    cli();
    tek_step_long_R_activ = command_step_long_R_activ;
    PORTB &= B11111011; //Отключаем сигнал шага
    schetchik_long_step_R = 0;// tek_step_long_R_activ;
    PORTB ^= B00000010;
    sei();
    real_napralenie_R = napralenie_R;
  }
}

//=========================================
//=========================================

void i_stepcoder() //Обработка по прерыванию
{
  //=========================================
  if (!schetchik_long_step_L)
  {
    schetchik_long_step_L = tek_step_long_L_activ;
    PORTB ^= B00010000;
  }
  schetchik_long_step_L--;
  //=========================================

  if (!schetchik_long_step_R)
  {
    schetchik_long_step_R = tek_step_long_R_activ;
    PORTB ^= B00000100;
  }
  schetchik_long_step_R--;
  //===================================================
}
//=========================================
//=========================================

void stepcoder_setup()
{
  schetchik_long_step_L = 0;
  schetchik_long_step_R = 0;
  flag_off_step_L = true;
  flag_off_step_R = true;
  PORTB = PORTB & B11101011; //Отключаем сигнал шага
  tek_step_long_L_activ = 65000;
  tek_step_long_R_activ = 65000;
  napralenie_L = true;
  napralenie_R = true;
  real_napralenie_L = napralenie_L;
  real_napralenie_R = napralenie_R;
  //PORTB = (PORTB & B11111101) | B00001000; //Задаем начальное направление на драйвера шаговиков.
  if (napralenie_R) PORTB &= B11111101;  else  PORTB |= B00000010; // Еще ускоряем
  if (napralenie_L) PORTB |= B00001000;  else  PORTB &= B11110111; // Еще ускоряем
  Timer1.initialize(12);  //longest pulse in PPM is usally 12 microseconds,
  Timer1.attachInterrupt(i_stepcoder);
}



